// Generated by CoffeeScript 1.12.7
(function() {
  var Input, Parser, Script, Writer;

  Writer = require('./util/writer');

  Parser = require('./util/parser');

  Script = require('./script');

  Input = (function() {
    function Input(_parsed, index) {
      var ref;
      this._parsed = _parsed != null ? _parsed : {};
      this.index = index != null ? index : 0;
      if (this._parsed instanceof Input) {
        return this._parsed;
      }
      if (!(this instanceof Input)) {
        return new Input(this._parsed, this.index);
      }
      if (typeof this._parsed === 'string') {
        return Parser(Input).parse(this._parsed);
      }
      if ((this._parsed.outputs != null)) {
        this._tx = this._parsed;
        this._output = this._tx.outputs[this.index];
        this.txid = this._tx.txid();
      } else {
        ref = this._parsed, this.txid = ref.txid, this.index = ref.index, this.script = ref.script, this.sequence = ref.sequence;
        this._script = this.script;
      }
      this.script = Script(this._script);
    }

    Input.prototype.output = function(transactions) {
      var ref, ref1;
      if (transactions == null) {
        transactions = {};
      }
      return (ref = this._output) != null ? ref : (ref1 = transactions[this.txid.toString('hex')]) != null ? ref1.outputs[this.index] : void 0;
    };

    Input.prototype.buf = function(input) {
      var ref, ref1, ref2, ref3, ref4, ref5;
      if (input == null) {
        input = {};
      }
      return Writer().reverse((ref5 = input.txid) != null ? ref5 : this.txid).uint32le((ref4 = input.index) != null ? ref4 : this.index).vardata((ref1 = (ref2 = (ref3 = input.script) != null ? typeof ref3.buf === "function" ? ref3.buf() : void 0 : void 0) != null ? ref2 : input.script) != null ? ref1 : this.script.buf()).uint32le((ref = input.sequence) != null ? ref : this.sequence).buf();
    };

    Input.prototype.sighash = function(outscript, transactions, subscript) {
      var ref;
      if (outscript == null) {
        outscript = false;
      }
      subscript = subscript != null ? subscript : (ref = this.output(transactions)) != null ? ref.script : void 0;
      if (outscript) {
        if (subscript == null) {
          throw new Error('output unknown');
        }
        return this.buf({
          script: subscript
        });
      } else {
        return this.buf({
          script: ''
        });
      }
    };

    Input.prototype.destination = function(transactions) {
      var ref, ref1;
      return (ref = (ref1 = this.output(transactions)) != null ? ref1.destination() : void 0) != null ? ref : [];
    };

    return Input;

  })();

  Input.template = [['txid', 'reverse:32'], ['index', 'uint32le'], ['script', 'vardata'], ['sequence', 'uint32le']];

  module.exports = Input;

}).call(this);
