// Generated by CoffeeScript 1.12.7
(function() {
  var Next, NextOpcodeBytes, Opcodes, Push, PushData, code, i, j, val;

  Next = function(handler) {
    return function(op) {
      var base;
      return typeof (base = op._reader)[handler] === "function" ? base[handler]() : void 0;
    };
  };

  NextOpcodeBytes = function(op) {
    return op.code[0];
  };

  PushData = function(stack, op) {
    return stack.push(op.data);
  };

  Push = function(val) {
    return function(stack) {
      return stack.push(val);
    };
  };

  Opcodes = {
    0x00: {
      identifiers: ['OP_FALSE', 'OP_0'],
      process: Push(0x00)
    },
    0x4c: {
      identifier: 'OP_PUSHDATA1',
      take: Next('uint8'),
      process: PushData
    },
    0x4d: {
      identifier: 'OP_PUSHDATA2',
      take: Next('uint16le'),
      process: PushData
    },
    0x4e: {
      identifier: 'OP_PUSHDATA4',
      take: Next('uint32le'),
      process: PushData
    },
    0x4f: {
      identifier: 'OP_1NEGATE',
      process: Push(-1)
    },
    0x51: {
      identifiers: ['OP_TRUE', 'OP_1'],
      process: Push(0x01)
    },
    0x75: {
      identifier: 'OP_DROP',
      process: function(stack) {
        return stack.push('TODO: OP_DROP');
      }
    },
    0x76: {
      identifier: 'OP_DUP',
      process: function(stack) {
        return stack.push('TODO: OP_DUP');
      }
    },
    0x88: {
      identifier: 'OP_EQUALVERIFY',
      process: function(stack) {
        return stack.push('TODO: OP_EQUALVERIFY');
      }
    },
    0xa9: {
      identifier: 'OP_HASH160',
      process: function(stack) {
        return stack.push('TODO: HASH160');
      }
    },
    0xac: {
      identifier: 'OP_CHECKSIG',
      process: function(stack) {
        return stack.push('TODO: OP_CHECKSIG');
      }
    }
  };

  for (code = i = 0x01; i <= 75; code = ++i) {
    Opcodes[code] = {
      take: NextOpcodeBytes,
      process: PushData
    };
  }

  for (code = j = 0x52; j <= 96; code = ++j) {
    val = code - 0x50;
    Opcodes[code] = {
      identifier: "OP_" + val,
      process: Push(val)
    };
  }

  module.exports = Opcodes;

}).call(this);
