// Generated by CoffeeScript 1.12.7
(function() {
  var Output, Parser, Reader, Script, Writer,
    slice = [].slice;

  Reader = require('./util/reader');

  Writer = require('./util/writer');

  Parser = require('./util/parser');

  Script = require('./script');

  Output = (function() {
    function Output(_parsed) {
      var ref;
      this._parsed = _parsed != null ? _parsed : {};
      if (!(this instanceof Output)) {
        return new Output(this._parsed);
      }
      if (typeof this._parsed === 'string') {
        return Parser(Output).parse(this._parsed);
      }
      ref = this._parsed, this.amount = ref.amount, this.script = ref.script;
      this._script = this.script;
      this.script = Script(this._script);
    }

    Output.prototype.assets = function() {
      var data, identifier, ref, type;
      ref = this.script.meta(), type = ref[0], data = 2 <= ref.length ? slice.call(ref, 1) : [];
      switch (type) {
        case 'p2pkhm':
          data = Reader(data[0]);
          return identifier = data.read(4).toString();
      }
    };

    Output.prototype.buf = function() {
      return Writer().uint64le(this.amount).vardata(this.script.buf()).buf();
    };

    Output.prototype.meta = function() {
      var classification, data, datum, meta, ref;
      ref = this.script.meta(), classification = ref[0], data = 2 <= ref.length ? slice.call(ref, 1) : [];
      meta = (function() {
        var i, len, results;
        results = [];
        for (i = 0, len = data.length; i < len; i++) {
          datum = data[i];
          results.push(this._meta(datum));
        }
        return results;
      }).call(this);
      return meta[0];
    };

    Output.prototype._meta = function(datum) {
      var base, name, ref;
      datum = Reader(datum);
      return (ref = typeof (base = Output.handlers)[name = datum.read(4).toString()] === "function" ? base[name](datum) : void 0) != null ? ref : 'unknown';
    };

    Output.prototype.destination = function() {
      return this.script.destination();
    };

    return Output;

  })();

  Output.template = [['amount', 'uint64le'], ['script', 'vardata']];

  Output.handlers = {
    spkq: function(reader) {
      var assets;
      assets = {};
      while (!reader.eof()) {
        assets[reader.reverse(16).toString('hex')] = reader.uint64le().toNumber();
      }
      return assets;
    },
    spkg: function(reader) {
      return reader.uint64le().toString(10);
    }
  };

  Output.p2pkh = function(hash, amount) {
    return Output({
      amount: amount,
      script: Script.p2pkh(hash)
    });
  };

  module.exports = Output;

}).call(this);
