// Generated by CoffeeScript 1.12.7
(function() {
  var Input, Output, Parser, Script, Transaction, Writer, ecc;

  ecc = require('ecc-tools');

  Parser = require('./util/parser');

  Writer = require('./util/writer');

  Input = require('./input');

  Output = require('./output');

  Script = require('./script');

  Transaction = (function() {
    function Transaction(_parsed) {
      var ref, ref1, ref2, ref3, ref4;
      this._parsed = _parsed != null ? _parsed : {};
      if (this._parsed instanceof Transaction) {
        return this._parsed;
      }
      if (!(this instanceof Transaction)) {
        return new Transaction(this._parsed);
      }
      if (typeof this._parsed === 'string') {
        return Parser(Transaction).parse(this._parsed);
      }
      ref = this._parsed, this.version = (ref1 = ref.version) != null ? ref1 : 1, this.inputs = (ref2 = ref.inputs) != null ? ref2 : [], this.outputs = (ref3 = ref.outputs) != null ? ref3 : [], this.locktime = (ref4 = ref.locktime) != null ? ref4 : 0;
      this.txs = {};
    }

    Transaction.prototype.buf = function(tx) {
      var ref;
      if (tx == null) {
        tx = {};
      }
      return Writer().uint32le(this.version).write((ref = tx.inputs) != null ? ref : this.inputs).write(this.outputs).uint32le(this.locktime).buf();
    };

    Transaction.prototype.txhash = function() {
      return ecc.sha256sha256(this.buf());
    };

    Transaction.prototype.txid = function() {
      return ecc.reverse(this.txhash());
    };

    Transaction.prototype.txin = function() {
      var input, j, len, ref, results;
      ref = this.inputs;
      results = [];
      for (j = 0, len = ref.length; j < len; j++) {
        input = ref[j];
        results.push(input.txid);
      }
      return results;
    };

    Transaction.prototype.txadd = function(tx) {
      var j, len, t;
      if (Array.isArray(tx)) {
        for (j = 0, len = tx.length; j < len; j++) {
          t = tx[j];
          this.txadd(t);
        }
      } else {
        tx = Transaction(tx);
        this.txs[tx.txid().toString('hex')] = tx;
      }
      return this;
    };

    Transaction.prototype.from = function(tx, index) {
      this.txadd(tx).inputs.push(Input(tx, index));
      return this;
    };

    Transaction.prototype.to = function(hash, amount) {
      this.outputs.push(Output.p2pkh(hash, amount));
      return this;
    };

    Transaction.prototype.sighash = function(index, type, subscript) {
      var buf, i, input;
      if (type == null) {
        type = 0x01;
      }
      buf = Writer(this.buf({
        inputs: (function() {
          var j, len, ref, results;
          ref = this.inputs;
          results = [];
          for (i = j = 0, len = ref.length; j < len; i = ++j) {
            input = ref[i];
            results.push(input.sighash(index === i, this.txs, subscript));
          }
          return results;
        }).call(this)
      })).write(type, 'writeInt32LE', 4).buf();
      return ecc.reverse(ecc.sha256sha256(buf));
    };

    Transaction.prototype.sign = function(private_key, type) {
      var hash, index, input, j, len, public_key, ref;
      public_key = ecc.publicKey(private_key, true);
      hash = ecc.sha256ripemd160(public_key).toString('hex');
      ref = this.inputs;
      for (index = j = 0, len = ref.length; j < len; index = ++j) {
        input = ref[index];
        if (input.destination(this.txs).indexOf(hash) !== -1) {
          input.script = Script.p2pkh_sig(private_key, this.sighash(index, type));
        }
      }
      return this;
    };

    return Transaction;

  })();

  Transaction.template = [['version', 'uint32le'], ['inputs', [Input]], ['outputs', [Output]], ['locktime', 'uint32le']];

  module.exports = Transaction;

}).call(this);
