// Generated by CoffeeScript 1.12.7
(function() {
  var BN, Reader;

  BN = require('bn.js');

  Reader = (function() {
    function Reader(_buf) {
      this._buf = _buf;
      if (this._buf instanceof Reader) {
        return this._buf;
      }
      if (!(this instanceof Reader)) {
        return new Reader(this._buf);
      }
      if (typeof this._buf === 'string') {
        this._buf = new Buffer(this._buf, 'hex');
      } else if (!Buffer.isBuffer(this._buf)) {
        throw new TypeError('invalid buffer');
      }
      this._pos = 0;
    }

    Reader.prototype.eof = function() {
      return this._pos >= this._buf.length;
    };

    Reader.prototype.read = function(len, handler) {
      var buf;
      if (handler == null) {
        handler = 'slice';
      }
      len = parseInt(len);
      buf = this._buf[handler](this._pos, this._pos + len);
      this._pos += len;
      return buf;
    };

    Reader.prototype.reverse = function(len, val) {
      var b, buf, i, j, len1;
      if (val == null) {
        val = this.read(len);
      }
      len = parseInt(len);
      buf = new Buffer(len);
      for (i = j = 0, len1 = val.length; j < len1; i = ++j) {
        b = val[i];
        buf[len - 1 - i] = b;
      }
      return buf;
    };

    Reader.prototype.compact = function() {
      var buf;
      buf = this.read(1);
      if (buf[0] <= 252) {
        return buf;
      } else {
        return this.read(Math.pow(2, buf[0] - 252));
      }
    };

    Reader.prototype.varint = function(buf) {
      if (buf == null) {
        buf = this.compact();
      }
      if (buf.length === 8) {
        return new BN(this.reverse(buf.length, buf).toString('hex'), 16);
      } else {
        return new BN(buf[['readUInt8', 'readUInt16LE', 'readUInt32LE'][Math.floor(buf.length / 2)]]());
      }
    };

    Reader.prototype.vardata = function() {
      return this.read(this.varint().toNumber());
    };

    Reader.prototype.uint8 = function() {
      return this.read(1, 'readUInt8');
    };

    Reader.prototype.uint16le = function() {
      return this.read(2, 'readUInt16LE');
    };

    Reader.prototype.uint16be = function() {
      return this.read(2, 'readUInt16BE');
    };

    Reader.prototype.uint32le = function() {
      return this.read(4, 'readUInt32LE');
    };

    Reader.prototype.uint32be = function() {
      return this.read(4, 'readUInt32BE');
    };

    Reader.prototype.uint64le = function() {
      return this.varint(this.read(8));
    };

    Reader.prototype.uint64be = function() {
      return this.varint(this.reverse(8));
    };

    return Reader;

  })();

  module.exports = Reader;

}).call(this);
