// Generated by CoffeeScript 1.12.7
(function() {
  var BN, Writer;

  BN = require('bn.js');

  Writer = (function() {
    function Writer(_buf) {
      this._buf = _buf != null ? _buf : '';
      if (this._buf instanceof Writer) {
        return this._buf;
      }
      if (!(this instanceof Writer)) {
        return new Writer(this._buf);
      }
      if (typeof this._buf === 'string') {
        this._buf = new Buffer(this._buf, 'hex');
      } else if (!Buffer.isBuffer(this._buf)) {
        throw new TypeError('invalid buffer');
      }
    }

    Writer.prototype.buf = function() {
      return this._buf;
    };

    Writer.prototype.write = function(buf, handler, alloc) {
      var b, j, len, ref, tmp;
      if (handler) {
        tmp = new Buffer(alloc);
        if (typeof tmp[handler] === "function") {
          tmp[handler](buf, 0);
        }
        this.write(tmp);
      } else if (Array.isArray(buf)) {
        this.varint(buf.length);
        for (j = 0, len = buf.length; j < len; j++) {
          b = buf[j];
          this.write(b);
        }
      } else {
        if (typeof buf === 'string') {
          buf = new Buffer(buf, 'hex');
        }
        this._buf = Buffer.concat([this._buf, (ref = typeof buf.buf === "function" ? buf.buf() : void 0) != null ? ref : buf]);
      }
      return this;
    };

    Writer.prototype.reverse = function(buf) {
      var b, i, j, len, tmp;
      if (typeof buf === 'string') {
        buf = new Buffer(buf, 'hex');
      }
      tmp = new Buffer(buf.length);
      for (i = j = 0, len = buf.length; j < len; i = ++j) {
        b = buf[i];
        tmp[buf.length - 1 - i] = b;
      }
      return this.write(tmp);
    };

    Writer.prototype.varint = function(int) {
      int = new BN(int);
      if (int.gte(new BN(0)) && int.lte(new BN(252))) {
        return this.uint8(int.toNumber());
      } else if (int.gte(new BN(253)) && int.lte(new BN('ffff', 16))) {
        return this.uint8(253).uint16le(int.toNumber());
      } else if (int.gte(new BN('10000', 16)) && int.lte(new BN('ffffffff', 16))) {
        return this.uint8(254).uint32le(int.toNumber());
      } else if (int.gte(new BN('100000000', 16)) && int.lte(new BN('ffffffffffffffff', 16))) {
        return this.uint8(255).uint64le(int);
      } else {
        throw Error('int too big for varint');
      }
    };

    Writer.prototype.vardata = function(buf) {
      if (typeof buf === 'string') {
        buf = new Buffer(buf, 'hex');
      }
      return this.varint(buf.length).write(buf);
    };

    Writer.prototype.uint8 = function(int) {
      return this.write(int, 'writeUInt8', 1);
    };

    Writer.prototype.uint16le = function(int) {
      return this.write(int, 'writeUInt16LE', 2);
    };

    Writer.prototype.uint16be = function(int) {
      return this.write(int, 'writeUInt16BE', 2);
    };

    Writer.prototype.uint32le = function(int) {
      return this.write(int, 'writeUInt32LE', 4);
    };

    Writer.prototype.uint32be = function(int) {
      return this.write(int, 'writeUInt32BE', 4);
    };

    Writer.prototype.uint64le = function(int) {
      return this.write((new BN(int)).toBuffer('le', 8));
    };

    Writer.prototype.uint64be = function(int) {
      return this.write((new BN(int)).toBuffer('be', 8));
    };

    return Writer;

  })();

  module.exports = Writer;

}).call(this);
