chai = require 'chai'
expect = chai.expect

Opcode = require '../src/opcode'
Reader = require '../src/util/reader'

describe 'Opcode', ->
  describe '#instance', ->
    it 'should return a Opcode instance', ->
      opcode = Opcode()
      expect(opcode).to.be.instanceof(Opcode)

    it 'should take a reader and read the next op', ->
      opcode = Opcode(Reader('01deadbeef'))
      expect(opcode.code[0]).is.equal(0x01)
      expect(opcode.data.toString('hex')).is.equal('de')
      expect(opcode._reader._pos).is.equal(2)

    it 'should set the identifier to the data if not defined', ->
      opcode = Opcode(Reader('04deadbeef'))
      expect(opcode.data.toString('hex')).is.equal('deadbeef')
      expect(opcode.identifier).is.equal('deadbeef')
